--[[
Saisie vocale français arabe.
Cette extension vous permettra d'utiliser la saisie vocale en arabe et en français.
Auteur : Abdelkrim bensaid.
Membre du groupe Jieshuo for arabs.
]]

require "import";
import "android.speech.RecognizerIntent";
import "com.androlua.LuaDialog";
import "android.speech.RecognitionListener";
import "android.speech.SpeechRecognizer";
import "android.content.Intent";
import "java.io.File";
import "java.io.FileInputStream";
import "java.io.FileWriter";
import "com.androlua.LuaUtil";
import "java.lang.String";
import "java.nio.charset.StandardCharsets";

-- Ceci est la liste des langues dictables.
local langs = {
    "Arabe",
    "Français"
};
local values = {
    "ar_SA",
    "fr_FR"
}

local selectedLangFilePath = service.getLuaExtDir() .. File.separator .. "selected_lang";
local file = File(selectedLangFilePath);
local edit = service.getEditText();

-- Cette fonction permettra de réaliser la saisie vocale.
function voiceRecognition(activity, lang)
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, lang);
    local recognitionListener = RecognitionListener {
        onResults = function(params)
            -- Ici, nous extrayons le texte que nous avons dicté.
            local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            -- Nous attribuons un objet au champ de saisie.
            local edit = service.getEditText();
            -- Nous attribuons un objet au texte que nous avons dicté.
            local text = tostring(results[0]);
            -- Nous lisons le texte.
            service.speak(text);
            task(200, function()
                -- Nous écrivons le texte dans le champ de saisie.
                service.insertText(edit, text);
            end)
        end,
    }
    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
end

if not edit or not file.exists() then -- Il n'y a pas de champ de saisie ou on utilise le plugin pour la première fois.
    dlg=LuaDialog()
    dlg.setTitle("Choix de la langue pour la saisie vocale");
    dlg.setMessage([[Choisissez la langue avec laquelle vous souhaitez procéder à la saisie vocale.
        Cette boîte de dialogue ne s'affiche qu'une seule fois  lors de la toute première utilisation de ce plugin depuis une zone de saisie.
            Elle s'affiche toujours lorsque vous exécutez ce plugin en dehors d'une zone comportant un champ d'édition.]]);
    
    dlg.setItems(langs);
    dlg.show();
    dlg.onItemClick=function(l,v,p,i)
        dlg.dismiss();
        task(50 , function()
            writer = FileWriter(selectedLangFilePath);
            writer.write(values[i]);
            writer.close();
                        if edit then
                voiceRecognition(this, values[i]);
                return
                            end
            service.speak(langs[i] .. [[ a été sélectionnée.
            Vous pouvez vous dirigez vers une zone de saisie pour effectuer votre saisie vocale]]);
        end);
    end
    return -- Nous ne faisons rien.
end

if file.exists() then
    local inputStream = FileInputStream(file);
    local selectedLang = LuaUtil.readAll(inputStream);
    selectedLang  = String(selectedLang, StandardCharsets.UTF_8);
    selectedLang  = tostring(selectedLang);
    voiceRecognition(this, selectedLang);
end
return true;